/*
	ga_configure.js
	Copyright © 2005 - 2015 WOT Services Oy <info@mywot.com>

	This file is part of WOT.

	WOT is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	WOT is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
	License for more details.

	You should have received a copy of the GNU General Public License
	along with WOT. If not, see <http://www.gnu.org/licenses/>.
*/

var wot_ga = {
	disable: false, // general switcher to stop counting stats
	_tracker: null,

	categories: {
		WS: "WarningScreen",
		RW: "RatingWindow",
		GEN: "General",
		INJ: "Injections",
		WT: "WelcomeTips",
		FBL: "FeedbackLoop"
	},

	actions: {
		RW_NOTARGET:   "RW_notarget",
		RW_TESTIMONY:   "RW_testimony",
		RW_TESTIMONY_DEL: "RW_testimony_del",
		RW_COMMENTADDED: "RW_comment_posted",
		RW_COMMENTREMOVED: "RW_comment_removed",
		RW_COMMENTKEPT: "RW_comment_kept",      // the comment is kept locally

		RW_BTN_CLOSE:   "RW_btn_close",
		RW_MSG_CLICKED: "RW_msg_clicked",
		RW_DELETE:      "RW_delete",
		RW_DELETEALL:   "RW_delete_all",
		RW_ADDCOMMENT:  "RW_addcomment",
		RW_EDITCOMMENT: "RW_editcomment",
		RW_PICKACAT:    "RW_pickcategory",
		RW_BTNCANCEL:   "RW_btn_cancel",
		RW_PROFILELNK:  "RW_profilelnk",

		WS_SHOW:        "WS_shown",
		WS_BTN_ENTER:   "WS_btn_enter",
		WS_BTN_CLOSE:   "WS_btn_close",

		D_POPUP_SHOWN:  "D_popup_shown",                    // Sent when user hovers over the donut on a search, label contains the rule name
		D_POPUP_TARGET_R0:      "D_popup_target_r0",        // Sent when user hovers over the donut on a search, label contains  the target name
		D_POPUP_TARGET_R1R2:    "D_popup_target_r1r2",
		D_POPUP_TARGET_R3:      "D_popup_target_r3",
		D_POPUP_TARGET_R4:      "D_popup_target_r4",
		D_POPUP_TARGET_R5:      "D_popup_target_r5",
		GEN_INSTALLED:  "WOT_installed",
//		GEN_LAUNCHED:   "WOT_launched",     // removed due to exceeding GA limits

		WT_INTRO_0_SHOWN: "WT_Intro0_shown",
		WT_INTRO_0_LEARN: "WT_Intro0_learnmore",
		WT_INTRO_0_OK:  "WT_Intro0_ok",
		WT_WS_SHOWN:    "WT_WS_shown",
		WT_WS_OK:       "WT_WS_ok",
		WT_WS_OPTEDOUT: "WT_WS_optedout",
		WT_WS_LEARN:    "WT_WS_learnmore",
		WT_RW_SHOWN:    "WT_RW_shown",
		WT_RW_OK:       "WT_RW_ok",
		WT_RW_LEARN:    "WT_RW_learnmore",
		WT_DONUTS_SHOWN:"WT_Donuts_shown",
		WT_DONUTS_OK:   "WT_Donuts_ok",
		WT_DONUTS_LEARN:"WT_Donuts_learnmore",

		FBL_shown:              "FBL_shown",
		FBL_submit:             "FBL_submit",
		FBL_TESTIMONY:          "FBL_testimony",
		FBL_closed:             "FBL_closed",
		FBL_dismiss:            "FBL_dismiss",
		FBL_optout_shown:       "FBL_optout_shown",
		FBL_optout_shown_smb:   "FBL_optout_shown:smb", // used for additional stats purposes: tells submittions number
		FBL_optout_yes:         "FBL_optout_yes",
		FBL_optout_yes_smb:     "FBL_optout_yes:smb",  // used for additional stats purposes: tells submittions number
		FBL_optout_no:          "FBL_optout_no",
		FBL_whatisthis:         "FBL_whatisthis",
		FBL_bottom_close:       "FBL_bottom_close",
		FBL_slidered:           "FBL_slidered",
		FBL_directclick:        "FBL_directclick",
		FBL_logo:               "FBL_logo",
		FBL_opportunity:        "FBL_opportunity"  // we could show the survey, but conditions are not met
	},

	init_tracker: function () {},

	fire_event: function (category, action, label, value) {
		if (wot_ga.disable) { return; }
	  
		var xhr = Cc["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Ci.nsIXMLHttpRequest);
		var url = "https://www.google-analytics.com/collect";
		var params = "v=1";
		params += "&tid=" + "UA-2412412-8"; //WOT_GA_ID //"GOOGLE ANALYTICS ID";
		params += "&cid=" + "9234603486104543266482"; // random --- part of pi number
		params += "&t=" + "event";
		if (category) {
			params += "&ec=" + category;
		}
		if (action) {
			params += "&ea=" + action;
		}
		if (label) {
			params += "&el=" + label;
		}
		if (value) {
			params += "&ev=" + value;
		}
	  
	  /*
	   * Used to send a random number in GET requests to ensure browsers and proxies don't cache hits.
	   * It should be sent as the final parameter of the request since we've seen some 3rd party internet 
	   * filtering software add additional parameters to HTTP requests incorrectly. 
	   * This value is not used in reporting.
	   */
		params += "&z=" + (1000000000 + Math.floor(Math.random() * (2147483647 - 1000000000)));

		xhr.open("POST", url, true);
		xhr.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE 
			| Components.interfaces.nsIRequest.INHIBIT_PERSISTENT_CACHING
			| Components.interfaces.nsIRequest.LOAD_ANONYMOUS;

	  	xhr.onreadystatechange = function() {
			if (xhr.readyState == 4) {}
		};

	  	xhr.send(params);
	}
};