try {
var EXPORTED_SYMBOLS = ["NavigationData"];
var { classes: Cc, interfaces: Ci, utils: Cu, results: Cr } = Components;

Cu.import("resource://wot-chrome-modules/log.js");
Cu.import("resource://wot-chrome-modules/CoreModuleGetter.js");
Cu.import("resource://wot-chrome-modules/Utils.js");

var DEBUG_ON = true;
if (!DEBUG_ON) { log = () => {}; warn = log; }

var wot_url = CoreModuleGetter.getModule("wot_url");

function NavigationData(docReferrerURL, docURL, lastURLNavigation) {
	this.docReferrerURL;
	this.docURL;
	this.lastURLNavigation;
	this.hostname;
	this.alreadyQueried;
	this._rtQuery; 			// added '_' to prevent mistakenly accessing the property

	this.init(docReferrerURL, docURL, lastURLNavigation);
};

NavigationData.prototype = new function() {
	this.init = function(docReferrerURL, docURL, lastURLNavigation) {
		this.docReferrerURL = docReferrerURL || "";
		this.docURL = docURL || "";
		this.hostname = this.docURL ? wot_url.gethostname(this.docURL) : "";
		this.lastURLNavigation = lastURLNavigation || "";
		this.alreadyQueried = false;
		this._rtQuery = null;

		if (!this.docURL) {
			log(new Error("NavigationData.init: 'docURL' is missing"));
		}
	};

	this.setAlreadyQueried = function() {
		this.alreadyQueried = true;
	};

	this.setRtQuery = function(value) {
		this._rtQuery = value;
	};

	this.toString = function() {
		var str = "******** BEGIN ********" + "\r\n";

		str += "URL: " + "\t\t" + (this.DocURL || "Not found") + "\r\n";
		str += "Referrer: " + "\t" + this.DocReferrerURL + "\r\n";
		str += "Last URL: " + "\t" + this.LastURLNavigation;
		str += "\r\n" + "********** END ********";

		return str;
	};

	Object.defineProperty(this, "DocReferrerURL", { 
		get: function() { return this.docReferrerURL || ""; }
	});

	Object.defineProperty(this, "DocURL", { 
		get: function() { return this.docURL || ""; }
	});

	Object.defineProperty(this, "Hostname", { 
		get: function() { return this.hostname || ""; }
	});	

	Object.defineProperty(this, "LastURLNavigation", { 
		get: function() { return this.lastURLNavigation || ""; }
	});

	Object.defineProperty(this, "IsAlreadyQueried", { 
		get: function() { return this.alreadyQueried; }
	});

	Object.defineProperty(this, "RtQuery", { 
		get: function() { 
			return this.alreadyQueried || this._rtQuery === null ? null : this._rtQuery; 
		}
	});	
};

} catch(ex) { log(ex); }