try { 
var EXPORTED_SYMBOLS = ["Utils"];
var { classes: Cc, interfaces: Ci, utils: Cu, results: Cr } = Components;

Cu.import("resource://wot-chrome-modules/log.js");
Cu.import("resource://gre/modules/Services.jsm");

var DEBUG_ON = true;
if (!DEBUG_ON) { log = () => {}; warn = log; }

var Utils = new function() {
	this.isWebURL = function(url) {
		return url.trim().toLowerCase().indexOf("http") == 0;
	};

    this.getMostRecentWindow = function() {
        return Services.wm.getMostRecentWindow("navigator:browser");
    };

    this.base64Encode = function(data) {
        var recentWin = Utils.getMostRecentWindow();

        return recentWin.btoa(data);
    };

    this.encodeURIComponent = function(data) {
        var recentWin = Utils.getMostRecentWindow();

        return recentWin.encodeURIComponent(data);
    };    
};

} catch(ex) { log(ex); }