/*
    dom_purify.js
    Copyright © 2005-2012  WOT Services Oy <info@mywot.com>

    This file is part of WOT.

    WOT is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WOT is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
    License for more details.

    You should have received a copy of the GNU General Public License
    along with WOT. If not, see <http://www.gnu.org/licenses/>.
*/

// source code - https://github.com/cure53/DOMPurify/blob/master/dist/purify.min.js

var wot_dom_purify = new function() {
    var { classes: Cc, interfaces: Ci, utils: Cu, results: Cr } = Components;

    const DOM_PURIFIER_SCRIPT_FILENAME = "chrome://wot/content/libs/purify.min.js";

    this.sandbox = null;

    this.load = function() {
        this.sandbox = Cu.Sandbox(window, {
            sandboxPrototype: window,
            wantXrays: false
        });
        
        var scriptloader = Cc["@mozilla.org/moz/jssubscript-loader;1"]
            .getService(Ci.mozIJSSubScriptLoader);        
        
        scriptloader.loadSubScript(DOM_PURIFIER_SCRIPT_FILENAME, this.sandbox, "UTF-8");
    };

    this.sanitize = function(dirty, cfg) {
        if (!this.sandbox) {
            console.log(new Error("wot_dom_purify.sanitize: 'this.sandbox' is null"));

            return dirty;
        }

        if (!this.sandbox.DOMPurify) {
            console.log(new Error("wot_dom_purify.sanitize: 'this.sandbox.DOMPurify' is undefined"));

            return dirty;
        }

        return this.sandbox.DOMPurify.sanitize(dirty, cfg);
    };
};

wot_modules.push({ name: "wot_dom_purify", obj: wot_dom_purify });