var SettingsPage = new function() {
	const SAVED_TEXT = "Saved";

	this.setting_map_rule = {
		warning_level_normal: function() {
			$("#min_confidence_level").val("8");
			$("#warning_level_0").val("39");
			$("#warning_level_4").val("0");
			$("#search_ignore_4").val("true");
			$("#warning_type_0").val("2");
			$("#warning_type_4").val("0");
			$("#settingsui_warnlevel").val("normal");

			$("#warning-level-parental").parents('.row').css("visibility","visible");
			$("#warning-level-normal").parents('.row').find(".subrows").slideToggle('fast');

			$(".subrow-3-1 .settings-trigger").trigger("click");
		},
		non_blocking_warning: function() {
			$("#warning_type_0").val("2");
			$("#warning_type_4").val("0");
		},
		blocking_warning: function() {
			$("#warning_type_0").val("3");
		},
		warning_level_light: function() {
			$("#warning_level_0").val("39");
			$("#warning_level_4").val("0");
			$("#warning_type_0").val("1");
			$("#warning_type_4").val("0");
			$("#settingsui_warnlevel").val("light");

			$("#warning-level-parental").parents('.row').css("visibility","visible");
			$("#warning-level-normal").parents('.row').find(".subrows").hide();
		},
		warning_level_off: function() {
			$("#warning_type_0").val("0");
			$("#warning_type_4").val("0");
			$("#settingsui_warnlevel").val("off");

			$("#warning-level-parental").parents('.row').css("visibility","hidden");
			$("#warning-level-normal").parents('.row').find(".subrows").hide();
		},
		warning_level_parental: function() {
			if ($("#warning-level-parental").val() == "1") {
				$("#warning_level_4").val("39");
				$("#warning_opacity").val("1");
				$("#search_ignore_4").val("false");
				$("#warning_type_4").val("3");
				$("#settingsui_parental").val("true");
			}
			else {
				$("#warning_level_4").val("0");
				$("#warning_opacity").val("0.7");
				$("#search_ignore_4").val("true");
				$("#warning_type_4").val("0");
				$("#settingsui_parental").val("false");
			}
		},
		search_level_normal: function() {
			$("#use_search_level").val("false");
			$("#search_level").val("101");
			$("#search_type").val("0");
			$("#settingsui_searchlevel").val("normal");

			$("#search_ignore_0").val("false");
		},
		search_level_bad: function() {
			$("#use_search_level").val("true");
			$("#search_level").val("60");
			$("#search_type").val("0");
			$("#settingsui_searchlevel").val("bad");

			$("#search_ignore_0").val("false");
		},
		search_level_all: function() {
			$("#use_search_level").val("true");
			$("#search_level").val("-2");
			$("#search_ignore_0").val("true");
			$("#search_ignore_4").val("true");
			$("#settingsui_searchlevel").val("off");
		},
	    dynamic_protect_on: function() {
	        $("#settingsui_dynamicprotect").val("true");
	    },
	    dynamic_protect_off: function() {
	        $("#settingsui_dynamicprotect").val("false");
	    },
		show_search_popup: function() {
			if($("#show-search-popup").val() == "1") {
				$("#show_search_popup").val("true");
			}else {
				$("#show_search_popup").val("false");
			}
		},
		my_cookies: function() {
			if($("#my-cookies").val() == "1") {
				$("#my_cookies").val("true");
			}else {
				$("#my_cookies").val("false");
			}
		},
		accessible_cb: function() {
			if($("#accessible-cb").val() == "1") {
				$("#accessible").val("true");
			}else {
				$("#accessible").val("false");
			}
		},
		show_rating_frame: function() {
			if($("#show-rating-frame").val() == "1") {
				$("#show_rating_frame").val("true");
			}else {
				$("#show_rating_frame").val("false");
			}
		},
		create_button: function() {
			if($("#create-button").val() == "1") {
				$("#create_button").val("true");
			}else {
				$("#create_button").val("false");
			}
		},
		private_disable: function() {
			if($("#private-disable").val() == "1") {
				$("#private_disable").val("true");
			}else {
				$("#private_disable").val("false");
			}
		},
		advanced_ignore_list: function() {
			if ($("#advanced-ignore-list").val() != $("#norepsfor").val()) {
				$("#norepsfor").val($("#advanced-ignore-list").val());
			}
		}
	};

	this.wotsettings_ready = function() {
		this.wotsettings_preselect_trigger();
		if ($("#advanced-ignore-list").length > 0) {
			$('#advanced-ignore-list').bind('input propertychange', function() {
				this.wotsettings_addon_trigger('advanced-ignore-list');
			});
		}
		$(".settings-trigger").on('click', function(event) {
			event.preventDefault();
			event.stopPropagation();
			// clean the saved elements
			$("#settings-saved").stop(true,true).remove();

			if ($(this).hasClass("radio") && !$(this).hasClass("select")) {
				// check if the option is belonged to subgroup
				if ($(this).parents('.subrows').length == 0) {
					// clean all the radio before selecting a new one
					$(this).parents(".settings-options").find(".input-radio .settings-option").removeClass("select");
					$(this).parents(".settings-options").find(".input-radio .option-text label").removeClass("select");
					$(this).parents(".settings-options").find(".input-radio input").attr("value", "0");
				}else {
					$(this).parents(".subrows").find(".settings-option").removeClass("select");
					$(this).parents(".subrows").find(".option-text label").removeClass("select");
					$(this).parents(".subrows").find("input").attr("value", "0");
				}
			}
			if ($(this).hasClass("select") && $(this).hasClass("radio")) {
				return true;
			}
			if ($(this).hasClass("select") && !$(this).hasClass("radio")) {
				$(this).removeClass("select");
				$(this).find(".option-text label").removeClass("select");
				$(this).find("input").attr("value","0");
				SettingsPage.wotsettings_styling($(this));
			}else {
				$(this).addClass("select");
				$(this).find(".option-text label").addClass("select");
				$(this).find("input").attr("value","1");
				SettingsPage.wotsettings_styling($(this));
			}
		});
		$(".advance-trigger").on('click',function(){
			var advance = $(this).parent();
			if (advance.hasClass("select")) {
				advance.removeClass("select");
			}else {
				advance.addClass("select");
			}
			advance.siblings(".settings-options").slideToggle('fast');
		});
		this.move_block();
	};

	this.wotsettings_styling = function(elem) {
		if (elem.parents('#advanced').length > 0) {
			if (elem.parents('#search-services').length > 0) {
				var settings_saved_class = "settings-saved-more-margin search-rules";
			}else {
				var settings_saved_class = "settings-saved-more-margin";
			}
		}else{
			var settings_saved_class = "";
		}
		if (elem.parents('.subrows').length > 0) {
			elem.parents('.subrows').siblings('.settings-option').before('<div id="settings-saved" class="'+settings_saved_class+'"><span class="settings-saved-text">'+SAVED_TEXT+'</span></div>');
		}else {
			elem.before('<div id="settings-saved" class="'+settings_saved_class+'"><span class="settings-saved-text">'+SAVED_TEXT+'</span></div>');
		}
		this.wotsettings_addon_trigger(elem.find("input").attr('id'));
	};

	this.wotsettings_preselect_trigger = function() {
		var warning = $("#settingsui_warnlevel").val();
		switch(warning) {
			case "light":
				var id = ".warning-level-light .settings-option";
				var val = "1";
				this.wotsettings_preselect(id,val);
				$("#warning-level-normal").parents('.row').find(".subrows").hide();
				break;
			case "off":
				var id = ".warning-level-off .settings-option";
				var val = "1";
				this.wotsettings_preselect(id,val);
				$("#warning-level-normal").parents('.row').find(".subrows").hide();
				break;
			default:
				var id = ".warning-level-normal .settings-option:not('.subrows .settings-option')";
				var val = "1";
				this.wotsettings_preselect(id,val);
				if ($("#warnings .row-3 .subrows").length > 0) {
					$("#warning-level-normal").parents('.row').find(".subrows").show();
					var warntype = $("#settingsui_warntype").val();
					var old_warntype = $("#warning_type_0").val();
					if (warntype == '3' || old_warntype == '3') {
						var id = ".blocking-warning .settings-option";
						var val = "1";
						this.wotsettings_preselect(id,val);
					}	else if (warntype == '2' || old_warntype == '2') {
						var id = ".non-blocking-warning .settings-option";
						var val = "1";
						this.wotsettings_preselect(id,val);
					}
				}
				break;
		}

		var parental = $("#settingsui_parental").val();
		var parental_old = $("#warning_type_4").val();
		if (parental == "true" || parental_old == '3') {
			var id = ".warning-level-parental .settings-option";
			var val = "1";
			this.wotsettings_preselect(id,val);
		}

		var search = $("#settingsui_searchlevel").val();
		switch(search) {
			case "bad":
				var id = ".search-level-bad .settings-option";
				var val = "1";
				this.wotsettings_preselect(id,val);
				break;
			case "off":
				var id = ".search-level-all .settings-option";
				var val = "1";
				this.wotsettings_preselect(id,val);
				break;
			default:
				var id = ".search-level-normal .settings-option";
				var val = "1";
				this.wotsettings_preselect(id,val);
				break;
		}

	    var dynamicprotect = $("#settingsui_dynamicprotect").val();

		if(dynamicprotect == "true"){
	        var id = ".dynamic-protect-on .settings-option";
	        var val = 1;
		} else {
	        var id = ".dynamic-protect-off .settings-option";
	        var val = 1;
	    }
	    this.wotsettings_preselect(id,val);

		var show_search_popup = $("#show_search_popup").val();
		if (show_search_popup == "true") {
			var id = ".show-search-popup .settings-option";
			var val = "1";
			this.wotsettings_preselect(id,val);
		}
		var my_cookies = $("#my_cookies").val();
		if (my_cookies == "true") {
			var id = ".my-cookies .settings-option";
			var val = "1";
			this.wotsettings_preselect(id,val);
		}
		var accessible = $("#accessible").val();
		if (accessible == "true") {
			var id = ".accessible-cb .settings-option";
			var val = "1";
			this.wotsettings_preselect(id,val);
		}
		var show_rating_frame = $("#show_rating_frame").val();
		if (show_rating_frame == "true") {
			var id = ".show-rating-frame .settings-option";
			var val = "1";
			this.wotsettings_preselect(id,val);
		}
		var create_button = $("#create_button").val();
		if (create_button == "true") {
			var id = ".create-button .settings-option";
			var val = "1";
			this.wotsettings_preselect(id,val);
		}
		var private_disable = $("#private_disable").val();
		if (private_disable == "true") {
			var id = ".private-disable .settings-option";
			var val = "1";
			this.wotsettings_preselect(id,val);
		}

		var advanced_ignore_list = $("#norepsfor").val();
		if ($("#advanced-ignore-list").length > 0) {
			$("#advanced-ignore-list").val(advanced_ignore_list);
		}
	};

	this.wotsettings_preselect = function(id, val) {
		$(id).addClass("select");
		$(id).find(".option-text label").addClass("select");
		$(id).find("input").attr("value",val);
	};

	this.build_search_rules = function(json_data) {
		var inject_elements = '';
		if (typeof(json_data) === 'string') {
			json_data = jQuery.parseJSON(json_data);
		}
		for (num in json_data) {
			var data = json_data[num];
			var value = data['state'] == true ? 1 : 0;
			var select = data['state'] == true ? 'select' : '';
			inject_elements += '<div class="search-rules-row-'+num+' input-checkbox">';
			inject_elements += '<div class="settings-option search-rules checkbox settings-trigger '+select+'">';
			inject_elements += '<input type="hidden" name="seaching-settings" id="'+data['id']+'" class="wotsearchpref" value="'+value+'" wotpref="bool">';
			inject_elements += '<div class="option-text"><label for="'+data['id']+'" class="type-checkbox '+select+'">'+data['display']+'</label></div>';
			inject_elements += '</div>';
			inject_elements += '<div class="clear"></div>';
			inject_elements += '</div>';
		}

		var sanitized_inject_elements = DOMPurify.sanitize(inject_elements);

		$("#search-services").html(sanitized_inject_elements);

		// 'DOMPurify.sanitize()' removes the "wotpref" attribute - add it back
		$("#search-services input").each(
			function(index, value) { 
				$(value).attr("wotpref", "bool");
			}
		);	
	};

	this.wotsettings_addon_trigger = function(id) {
		if ($("#wotsave").length > 0) {
			var get_function = id.replace(/-/g,"_");
			if (typeof this.setting_map_rule[get_function] == "function") {
				this.setting_map_rule[get_function]();
			}
			$("#wotsave").trigger("click");
		}
	};

	this.wotsettings_saved = function() {
		$("#settings-saved").fadeIn(function(){
			$("#settings-saved").delay(2000).fadeOut();
		});
	};

	this.move_block = function() {
	    if($('#settingsui_dynamicprotect').val() == 'true') {
	        $('#dynamic-protect').insertAfter($('#search'));
	        $('#dynamic-protect').removeClass('attention-icon');
	    } else {
	        $('#dynamic-protect').insertBefore($('#warnings'));
	        $('#dynamic-protect').addClass('attention-icon');
	    }
	};
};